#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_config_save_view.pl
#
# Version:  @(#)$Revision$
#
# Purpose:  
#
#   Specs: 
#
#  Author:  Bill Border
# !*-------------------------------------------------------------------------

$| = 1;
$P = "dbamon_config_save_view.pl";
require "cgi_handlers.pl";

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

use DBI;
require "cgi_handlers.pl";

# General parms required
##$DBdir         = "/var/opt/apache/htdocs/cftasks";
##$modlockfile   = "$DBdir/modlock";
##$entlockfile   = "$DBdir/entlock";
##$conlockfile   = "$DBdir/conlock";
##$modfile       = "$DBdir/modEntries";
##$cfteamFile    = "$DBdir/cfteam";
##$entityFile    = "$DBdir/entities";

chop($date     = `date`);
chop($host     = `hostname`);

$company = ""; 
# Save Company name
$compwork = `nslookup $host | grep Name: | awk '{ print \$2 }'`;
chop $compwork;
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];


#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b>\n";
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body><font face=$font>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   ##$sqlerror = $DBI::errstr;
   ##print "<br>SQL statement: $statement";
   ##print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub readData
#-----------------------------------------------------------------------------
{
  &msg("Reading from Configuration Save File: ($configsavefile) on host=$host"); 
  $configdata = `cat $configsavefile 2>&1`; 

  print "
  <p>
  <table bgcolor=linen border=0><tr><td>
  <fieldset>
   <legend><b>Configuration Save Data - File: $configsavefile on Host: $host<b></legend>
   <pre><b><zfont size=2 face=verdana color=darkblue>$configdata</pre>
  </fieldset>
  </table>
  "; 
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{

   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

&get_request;

@words = split(/,/,$ARGV[0]);
$configsavefile = $words[0];

&header("Config_Save File Viewer");
&msg("Starting - version=$version - mode=($mode) file=($configsavefile)");

&readData;

&msg("Done");
exit 0;
