#-------------------------------------------------------------------------------
sub histCreate
#-------------------------------------------------------------------------------
# Create a row in the Oracle dbamon.history table 
{
  my ($caller, $h, $c, $p, $v, $v2, $v3) = @_;

  $debug_hc = 0; 

  if ($v eq "" || $v < 0) 
  {
    $v = -1;   # Hmmmm?????
  }
  if ($v2 eq "" || $v2 < 0) 
  {
    $v2 = -1;   # Hmmmm?????
  }
  if ($v3 eq "" || $v3 < 0) 
  {
    $v3 = -1;   # Hmmmm?????
  }
  #---- BB 25May04 - MSSQL has some long DB names.
  if ($p =~ /\[HYPHEN\]/)
  {
    $p =~ s/\[HYPHEN\]/\-/g;
  }

  $titlehist[$h] = "?" if !$titlehist[$h];
  #---- The db name can be very long for MSSQL - deal with that
  $p = substr($p,0,31) . "+" if length($p) >= 32; 

  #---- 4.08 BB - Now do this every iteration
  #---- if ($iter_count == 1 || ($iter_count/10 == int($iter_count/10)))   # Do this on the first and every 10th iteration
  if (1 == 1)
  {
    #---- Added 2010/11/18 BB
    ##chop($ztoday = `date +%Y/%m/%d`);
    $ztoday = substr(&getdate,0,10); 
    ##print "ztoday=$ztoday\n"; 

    $statement  = "
      insert into dbamon.history
	(dbamonmode,instance,system,dbms,category,parm,value,value2,value3,zdate)
      values
        (\'$mode\',\'$titlehist[$h]\', \'$hostname[$h]\', \'$dbmsout[$h]\', \'$c\', \'$p\',$v,$v2,$v3,'$ztoday')
    ";

    print "DEBUG - statement=$statement\n" if $debug_hc;
    runSQL($statement,1);
    print "DEBUG - sqlerror=$sqlerror sqlcode=$sqlcode\n" if $debug_hc;

    if ($sqlcode != 0)
    {
      if ($sqlcode == 1)
      {
	##&logit("Duplicate dbamon.history row (normal)",$h);
	$returnrc = 2;
      }
      else
      {
        open(TMPFL7,">$tmpfl7") ||  &error_msg("Can't open output $tmpfl7 - $!");
        print TMPFL7 "statement=$statement \n";
        print TMPFL7 "sqlcode=$sqlcode \n";
        print TMPFL7 "sqlerror=$sqlerror \n";
        close(TMPFL7);
	&error_msg("Insert_into_history_error sqlerror=$sqlerror",$h,$tmpfl7);
      }
    }
    else
    {
      &logit("dbamon.history $c Data Created",$h);
      $hist_row_inserted = 1;
    }
  }
  else
  {
    #$msg = sprintf("histCreate() Not this iteration (%s) - returning",$iter_count);
    #&logit($msg,$h);
  }
}
#-------------------------------------------------------------------------------
1;
